## pcl 1.8.1+dfsg1

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(POLICY CMP0017)
  # Do not include files in CMAKE_MODULE_PATH from files
  # in CMake module directory. Fix MXE build
  cmake_policy(SET CMP0017 NEW)
endif()

if(POLICY CMP0020 AND (WIN32 AND NOT MINGW))
  cmake_policy(SET CMP0020 NEW) # Automatically link Qt executables to qtmain target on Windows
endif()

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 OLD) # do not use VERSION option in project() command
endif()

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 OLD) # Silent warnings about quoted variables
endif()

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif("${CMAKE_BUILD_TYPE}" STREQUAL "")

project(PCL)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Include pkgconfig
include (FindPkgConfig)

# ---[ Release/Debug specific flags
if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  add_definitions("-DBOOST_DISABLE_ASSERTS -DEIGEN_NO_DEBUG")
endif()
if(WIN32 AND NOT MINGW)
  if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "_debug")
  endif()
  if(NOT DEFINED CMAKE_RELEASE_POSTFIX)
    set(CMAKE_RELEASE_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_RELWITHDEBINFO_POSTFIX)
    set(CMAKE_RELWITHDEBINFO_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_MINSIZEREL_POSTFIX)
    set(CMAKE_MINSIZEREL_POSTFIX "_release")
  endif()
endif()

# ---[ special maintainer mode
SET(CMAKE_CXX_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C++ compiler during maintainer builds."
    FORCE)
SET(CMAKE_C_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C compiler during maintainer builds."
    FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used for linking binaries during maintainer builds."
    FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used by the shared libraries linker during maintainer builds."
    FORCE)
MARK_AS_ADVANCED(
    CMAKE_CXX_FLAGS_MAINTAINER
    CMAKE_C_FLAGS_MAINTAINER
    CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    CMAKE_SHARED_LINKER_FLAGS_MAINTAINER )
# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
SET(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Maintainer."
    FORCE)

# Compiler identification
# Define a variable CMAKE_COMPILER_IS_X where X is the compiler short name.
# Note: CMake automatically defines one for GNUCXX, nothing to do in this case.
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif(__COMPILER_PATHSCALE)
  set(CMAKE_COMPILER_IS_PATHSCALE 1)
elseif(MSVC)
  set(CMAKE_COMPILER_IS_MSVC 1)
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_options.cmake")

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# check for SSE flags
include("${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake")
if (PCL_ENABLE_SSE)
  PCL_CHECK_FOR_SSE()
endif (PCL_ENABLE_SSE)

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS}")

    # Enable -Wabi for GCC > 4.3, and -Wno-deprecated for GCC < 4.3
    # to disable a lot of warnings which are not fixable
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.3)
      message(STATUS "-- GCC > 4.3 found, enabling -Wabi")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi")
    else()
      message(STATUS "-- GCC < 4.3 found, enabling -Wno-deprecated")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
    endif ()
  endif()

  if(NOT ANDROID)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif(NOT ANDROID)

  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "" AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed")
  endif()

  if(WIN32)
    if(PCL_SHARED_LIBS)
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if (MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
        SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--allow-multiple-definition")
      endif()
    else(PCL_SHARED_LIBS)
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif(PCL_SHARED_LIBS)
  endif()
endif()

if(CMAKE_COMPILER_IS_MSVC)
  add_definitions("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -DPCL_ONLY_CORE_POINT_TYPES /bigobj ${SSE_DEFINITIONS}")
  if("${CMAKE_CXX_FLAGS}" STREQUAL " /DWIN32 /D_WINDOWS /W3 /GR /EHsc")	# Check against default flags
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS}")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
      SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG /OPT:REF")
      SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    endif(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if( MSVC_VERSION GREATER 1500 AND ${CMAKE_VERSION} VERSION_GREATER "2.8.6")
      include(ProcessorCount)
      ProcessorCount(N)
      if(NOT N EQUAL 0)
        SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP${N} ")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP${N} ")
      endif()
    endif()
  endif()
endif()

if(CMAKE_COMPILER_IS_PATHSCALE)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -pthread -mp")
  endif()
  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "")
    SET(CMAKE_SHARED_LINKER_FLAGS "-mp")
  endif()
endif()

if(CMAKE_COMPILER_IS_CLANG)
  if("${CMAKE_C_FLAGS}" STREQUAL "")
    SET(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-ftemplate-depth=1024 -Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
    if(APPLE AND WITH_CUDA AND CUDA_FOUND)
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
    endif()
  endif()
  SET(CLANG_LIBRARIES "stdc++")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake")
set(PCL_VERSION "1.8.1" CACHE STRING "PCL version")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR "${PCL_SOURCE_DIR}/resources")
  set(PCL_POINTCLOUDS_DIR "${PCL_RESOURCES_DIR}/pointclouds")
endif(WIN32)

set(PCL_OUTPUT_LIB_DIR "${PCL_BINARY_DIR}/${LIB_INSTALL_DIR}")
set(PCL_OUTPUT_BIN_DIR "${PCL_BINARY_DIR}/${BIN_INSTALL_DIR}")
make_directory("${PCL_OUTPUT_LIB_DIR}")
make_directory("${PCL_OUTPUT_BIN_DIR}")
if(WIN32)
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif(WIN32)

# Add an "uninstall" target
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
IF("${is_system_dir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
ENDIF("${is_system_dir}" STREQUAL "-1")

### ---[ Find universal dependencies
# the gcc-4.2.1 coming with MacOS X is not compatible with the OpenMP pragmas we use, so disabling OpenMP for it
if((NOT APPLE) OR (NOT CMAKE_COMPILER_IS_GNUCXX) OR (GCC_VERSION VERSION_GREATER 4.2.1) OR (CMAKE_COMPILER_IS_CLANG))
  find_package(OpenMP)
endif()
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  message (STATUS "Found OpenMP")
  if(MSVC)
    if(MSVC_VERSION EQUAL 1500)
      set(OPENMP_DLL VCOMP90)
    elseif(MSVC_VERSION EQUAL 1600)
      set(OPENMP_DLL VCOMP100)
    elseif(MSVC_VERSION EQUAL 1700)
      set(OPENMP_DLL VCOMP110)
    elseif(MSVC_VERSION EQUAL 1800)
      set(OPENMP_DLL VCOMP120)
    elseif(MSVC_VERSION EQUAL 1900)
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION EQUAL 1910)
      set(OPENMP_DLL VCOMP140)
    endif()
    if(OPENMP_DLL)
      set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DELAYLOAD:${OPENMP_DLL}D.dll")
      set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DELAYLOAD:${OPENMP_DLL}.dll")
    else(OPENMP_DLL)
      message(WARNING "Delay loading flag for OpenMP DLL is invalid.")
    endif(OPENMP_DLL)
  endif(MSVC)
else(OPENMP_FOUND)
  message (STATUS "Not found OpenMP")
endif()

# Eigen (required)
find_package(Eigen REQUIRED)
include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})

# FLANN (required)
if(NOT PCL_SHARED_LIBS OR ((WIN32 AND NOT MINGW) AND NOT PCL_BUILD_WITH_FLANN_DYNAMIC_LINKING_WIN32))
  set(FLANN_USE_STATIC ON)
endif(NOT PCL_SHARED_LIBS OR ((WIN32 AND NOT MINGW) AND NOT PCL_BUILD_WITH_FLANN_DYNAMIC_LINKING_WIN32))
find_package(FLANN 1.7.0 REQUIRED)
include_directories(${FLANN_INCLUDE_DIRS})

# libusb-1.0
option(WITH_LIBUSB "Build USB RGBD-Camera drivers" TRUE)
if(WITH_LIBUSB)
  find_package(libusb-1.0)
  if(LIBUSB_1_FOUND)
    include_directories("${LIBUSB_1_INCLUDE_DIR}")
  endif(LIBUSB_1_FOUND)
endif(WITH_LIBUSB)

# Dependencies for different grabbers
PCL_ADD_GRABBER_DEPENDENCY("OpenNI" "OpenNI grabber support")
PCL_ADD_GRABBER_DEPENDENCY("OpenNI2" "OpenNI2 grabber support")
PCL_ADD_GRABBER_DEPENDENCY("FZAPI" "Fotonic camera support")
PCL_ADD_GRABBER_DEPENDENCY("Ensenso" "IDS-Imaging Ensenso camera support")
PCL_ADD_GRABBER_DEPENDENCY("davidSDK" "David Vision Systems SDK support")
PCL_ADD_GRABBER_DEPENDENCY("DSSDK" "DepthSense SDK support")
PCL_ADD_GRABBER_DEPENDENCY("RSSDK" "RealSense SDK support")

# metslib
if (PKG_CONFIG_FOUND)

=== 2d/CMakeLists.txt ===
set(SUBSYS_NAME 2d)
set(SUBSYS_DESC "Point cloud 2d")
set(SUBSYS_DEPS common io filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS vtk)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)

    set(srcs
        src/convolution_2d.cpp 
        )

    set(incs
        "include/pcl/${SUBSYS_NAME}/convolution.h"
        "include/pcl/${SUBSYS_NAME}/kernel.h"
        "include/pcl/${SUBSYS_NAME}/edge.h"
        "include/pcl/${SUBSYS_NAME}/morphology.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/edge.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/morphology.hpp"
        )

    if(${VTK_FOUND})
        set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
        include("${VTK_USE_FILE}")
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging)
    endif(${VTK_FOUND})

    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" ${VTK_INCLUDE_DIRECTORIES})

    #Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
    
endif(build)

=== apps/CMakeLists.txt ===
set(SUBSYS_NAME apps)
set(SUBSYS_DESC "Application examples/samples that show how PCL works")
set(SUBSYS_DEPS common geometry io filters sample_consensus segmentation visualization kdtree features surface octree registration keypoints tracking search recognition ml stereo)

set(DEFAULT FALSE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk)

if(build)

  include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/include")

  PCL_ADD_EXECUTABLE(pcl_test_search_speed "${SUBSYS_NAME}" src/test_search.cpp)
  target_link_libraries(pcl_test_search_speed pcl_common pcl_io pcl_search pcl_kdtree pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_nn_classification_example "${SUBSYS_NAME}" src/nn_classification_example.cpp)
  target_link_libraries(pcl_nn_classification_example pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE(pcl_pyramid_surface_matching "${SUBSYS_NAME}" src/pyramid_surface_matching.cpp)
  target_link_libraries(pcl_pyramid_surface_matching pcl_common pcl_io pcl_features pcl_registration pcl_filters)

  PCL_ADD_EXECUTABLE(pcl_statistical_multiscale_interest_region_extraction_example "${SUBSYS_NAME}" src/statistical_multiscale_interest_region_extraction_example.cpp)
  target_link_libraries(pcl_statistical_multiscale_interest_region_extraction_example pcl_common pcl_io pcl_features pcl_filters)

  if(LIBUSB_1_FOUND)
    PCL_ADD_EXECUTABLE(pcl_dinast_grabber "${SUBSYS_NAME}" src/dinast_grabber_example.cpp)
    target_link_libraries(pcl_dinast_grabber pcl_common pcl_visualization pcl_io)
  endif(LIBUSB_1_FOUND)

  if (VTK_FOUND)

    include("${VTK_USE_FILE}")

    set(incs "include/pcl/${SUBSYS_NAME}/render_views_tesselated_sphere.h")
    set(srcs "src/render_views_tesselated_sphere.cpp")

    PCL_ADD_EXECUTABLE(pcl_ppf_object_recognition "${SUBSYS_NAME}" src/ppf_object_recognition.cpp)
    target_link_libraries(pcl_ppf_object_recognition pcl_common pcl_io pcl_filters pcl_features pcl_registration pcl_visualization pcl_sample_consensus pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_multiscale_feature_persistence_example "${SUBSYS_NAME}" src/multiscale_feature_persistence_example.cpp)
    target_link_libraries(pcl_multiscale_feature_persistence_example pcl_common pcl_io pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_surfel_smoothing_test "${SUBSYS_NAME}" src/surfel_smoothing_test.cpp)
    target_link_libraries(pcl_surfel_smoothing_test pcl_common pcl_io pcl_surface pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_feature_matching "${SUBSYS_NAME}" src/feature_matching.cpp)
    target_link_libraries(pcl_feature_matching pcl_common pcl_io pcl_registration pcl_keypoints pcl_sample_consensus pcl_visualization pcl_search pcl_features pcl_kdtree pcl_surface pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_convolve "${SUBSYS_NAME}" src/convolve.cpp)
    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_pcd_organized_multi_plane_segmentation "${SUBSYS_NAME}" src/pcd_organized_multi_plane_segmentation.cpp)
    target_link_libraries(pcl_pcd_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

    if (QHULL_FOUND)
        PCL_ADD_EXECUTABLE(pcl_pcd_select_object_plane "${SUBSYS_NAME}" src/pcd_select_object_plane.cpp)
        target_link_libraries(pcl_pcd_select_object_plane pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_surface)
    endif()

#    PCL_ADD_EXECUTABLE(pcl_convolve "${SUBSYS_NAME}" src/convolve.cpp)
#    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_pcd_organized_edge_detection "${SUBSYS_NAME}" src/pcd_organized_edge_detection.cpp)
    target_link_libraries(pcl_pcd_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_face_trainer "${SUBSYS_NAME}" src/face_detection/face_trainer.cpp)
    target_link_libraries(pcl_face_trainer pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

    PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_fs_face_detector "${SUBSYS_NAME}" src/face_detection//filesystem_face_detection.cpp)
    target_link_libraries(pcl_fs_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

    PCL_ADD_EXECUTABLE(pcl_stereo_ground_segmentation "${SUBSYS_NAME}" src/stereo_ground_segmentation.cpp)
    target_link_libraries(pcl_stereo_ground_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_stereo)

    if (QT4_FOUND AND VTK_USE_QVTK)

      # Manual registration demo
      QT4_WRAP_UI(manual_registration_ui src/manual_registration/manual_registration.ui)
      QT4_WRAP_CPP(manual_registration_moc include/pcl/apps/manual_registration.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_manual_registration "${SUBSYS_NAME}" ${manual_registration_ui} ${manual_registration_moc} src/manual_registration/manual_registration.cpp)
      target_link_libraries(pcl_manual_registration pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

      QT4_WRAP_UI(pcd_video_player_ui src/pcd_video_player/pcd_video_player.ui)
      QT4_WRAP_CPP(pcd_video_player_moc include/pcl/apps/pcd_video_player.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_pcd_video_player "${SUBSYS_NAME}" ${pcd_video_player_ui} ${pcd_video_player_moc} src/pcd_video_player/pcd_video_player.cpp)
      target_link_libraries(pcl_pcd_video_player pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

    endif (QT4_FOUND AND VTK_USE_QVTK)

    if (WITH_OPENNI)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_frame "${SUBSYS_NAME}" src/openni_grab_frame.cpp)
#      target_link_libraries(pcl_openni_grab_frame pcl_common pcl_io pcl_visualization)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_images "${SUBSYS_NAME}" src/openni_grab_images.cpp)
#      target_link_libraries(pcl_openni_grab_images pcl_common pcl_io pcl_visualization)


      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_fast_mesh "${SUBSYS_NAME}" src/openni_fast_mesh.cpp)
      target_link_libraries(pcl_openni_fast_mesh pcl_common pcl_io pcl_visualization pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_voxel_grid "${SUBSYS_NAME}" src/openni_voxel_grid.cpp)
      target_link_libraries(pcl_openni_voxel_grid pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_octree_compression "${SUBSYS_NAME}" src/openni_octree_compression.cpp)
      target_link_libraries(pcl_openni_octree_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)

      if(HAVE_PNG)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_compression "${SUBSYS_NAME}" src/openni_organized_compression.cpp)
        target_link_libraries(pcl_openni_organized_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)
      endif(HAVE_PNG)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_shift_to_depth_conversion "${SUBSYS_NAME}" src/openni_shift_to_depth_conversion.cpp)
      target_link_libraries(pcl_openni_shift_to_depth_conversion pcl_common pcl_visualization)

      PCL_ADD_EXECUTABLE(pcl_openni_mobile_server "${SUBSYS_NAME}" src/openni_mobile_server.cpp)
      target_link_libraries(pcl_openni_mobile_server pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_planar_segmentation "${SUBSYS_NAME}" src/openni_planar_segmentation.cpp)
      target_link_libraries(pcl_openni_planar_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_multi_plane_segmentation "${SUBSYS_NAME}" src/openni_organized_multi_plane_segmentation.cpp)
      target_link_libraries(pcl_openni_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_ii_normal_estimation "${SUBSYS_NAME}" src/openni_ii_normal_estimation.cpp)
      target_link_libraries(pcl_openni_ii_normal_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_feature_persistence "${SUBSYS_NAME}" src/openni_feature_persistence.cpp)
      target_link_libraries(pcl_openni_feature_persistence pcl_common pcl_io pcl_filters pcl_visualization pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_mls_smoothing "${SUBSYS_NAME}" src/openni_mls_smoothing.cpp)
      target_link_libraries(pcl_openni_mls_smoothing pcl_common pcl_io pcl_surface pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_change_viewer "${SUBSYS_NAME}" src/openni_change_viewer.cpp)
      target_link_libraries(pcl_openni_change_viewer pcl_common pcl_io pcl_kdtree pcl_octree pcl_visualization pcl_filters)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_uniform_sampling "${SUBSYS_NAME}" src/openni_uniform_sampling.cpp)
      target_link_libraries(pcl_openni_uniform_sampling pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface pcl_keypoints)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_boundary_estimation "${SUBSYS_NAME}" src/openni_boundary_estimation.cpp)
      target_link_libraries(pcl_openni_boundary_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_edge_detection "${SUBSYS_NAME}" src/openni_organized_edge_detection.cpp)
      target_link_libraries(pcl_openni_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_face_detector "${SUBSYS_NAME}" src/face_detection//openni_face_detection.cpp src/face_detection//openni_frame_source.cpp)
      target_link_libraries(pcl_openni_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

      if (QT4_FOUND AND VTK_USE_QVTK)
        # OpenNI Passthrough application demo
        QT4_WRAP_UI(openni_passthrough_ui src/openni_passthrough.ui)
        QT4_WRAP_CPP(openni_passthrough_moc include/pcl/apps/openni_passthrough.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE(pcl_openni_passthrough "${SUBSYS_NAME}" ${openni_passthrough_ui} ${openni_passthrough_moc} src/openni_passthrough.cpp)
        target_link_libraries(pcl_openni_passthrough pcl_common pcl_io pcl_filters pcl_visualization ${QVTK_LIBRARY} ${QT_LIBRARIES})

        # OpenNI Organized Connected Component application demo
        QT4_WRAP_UI(organized_segmentation_demo_ui src/organized_segmentation_demo.ui)
        QT4_WRAP_CPP(organized_segmentation_demo_moc include/pcl/apps/organized_segmentation_demo.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_organized_segmentation_demo "${SUBSYS_NAME}" ${organized_segmentation_demo_ui} ${organized_segmentation_demo_moc} src/organized_segmentation_demo.cpp)

=== common/CMakeLists.txt ===
set(SUBSYS_NAME common)
set(SUBSYS_DESC "Point cloud common library")
set(SUBSYS_DEPS)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS eigen boost)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(range_image_incs
        include/pcl/range_image/bearing_angle_image.h
        include/pcl/range_image/range_image.h
        include/pcl/range_image/range_image_planar.h
        include/pcl/range_image/range_image_spherical.h
        )
  
    set(range_image_incs_impl
        include/pcl/range_image/impl/range_image.hpp
        include/pcl/range_image/impl/range_image_planar.hpp
        include/pcl/range_image/impl/range_image_spherical.hpp
        )

    set(range_image_srcs
        src/bearing_angle_image.cpp
        src/range_image.cpp
        src/range_image_planar.cpp
        )

    set(srcs 
        src/point_types.cpp
        src/pcl_base.cpp
        src/io.cpp
        src/common.cpp
        src/correspondence.cpp
        src/distances.cpp
        src/parse.cpp
        src/poses_from_matches.cpp
        src/print.cpp
        src/projection_matrix.cpp
        src/time_trigger.cpp
        src/gaussian.cpp
        src/colors.cpp
        src/feature_histogram.cpp
        ${range_image_srcs}
        )

    set(incs 
        include/pcl/correspondence.h
        include/pcl/exceptions.h
        include/pcl/pcl_base.h
        include/pcl/pcl_exports.h
        include/pcl/pcl_macros.h
        include/pcl/point_cloud.h
        include/pcl/point_traits.h
        include/pcl/point_types_conversion.h
        include/pcl/point_representation.h
        include/pcl/point_types.h
        include/pcl/for_each_type.h
        include/pcl/pcl_tests.h
        include/pcl/cloud_iterator.h
        include/pcl/TextureMesh.h
        include/pcl/sse.h
        include/pcl/PCLPointField.h
        include/pcl/PCLPointCloud2.h
        include/pcl/PCLImage.h
        include/pcl/PCLHeader.h
        include/pcl/ModelCoefficients.h
        include/pcl/PolygonMesh.h
        include/pcl/Vertices.h
        include/pcl/PointIndices.h
        include/pcl/register_point_struct.h
        include/pcl/conversions.h
        )

    set(common_incs 
        include/pcl/common/boost.h
        include/pcl/common/angles.h
        include/pcl/common/bivariate_polynomial.h
        include/pcl/common/centroid.h
        include/pcl/common/concatenate.h
        include/pcl/common/common.h
        include/pcl/common/common_headers.h
        include/pcl/common/distances.h
        include/pcl/common/eigen.h
        include/pcl/common/copy_point.h
        include/pcl/common/io.h
        include/pcl/common/file_io.h
        include/pcl/common/intersections.h
        include/pcl/common/norms.h
        include/pcl/common/piecewise_linear_function.h
        include/pcl/common/polynomial_calculations.h
        include/pcl/common/poses_from_matches.h
        include/pcl/common/time.h
        include/pcl/common/time_trigger.h
        include/pcl/common/transforms.h
        include/pcl/common/transformation_from_correspondences.h
        include/pcl/common/vector_average.h
        include/pcl/common/pca.h
        include/pcl/common/point_tests.h
        include/pcl/common/synchronizer.h
        include/pcl/common/utils.h
        include/pcl/common/geometry.h
        include/pcl/common/gaussian.h
        include/pcl/common/point_operators.h
        include/pcl/common/spring.h
        include/pcl/common/intensity.h
        include/pcl/common/random.h
        include/pcl/common/generate.h
        include/pcl/common/projection_matrix.h
        include/pcl/common/colors.h
        include/pcl/common/feature_histogram.h
        )

    set(common_incs_impl
        include/pcl/common/impl/angles.hpp
        include/pcl/common/impl/bivariate_polynomial.hpp
        include/pcl/common/impl/centroid.hpp
        include/pcl/common/impl/common.hpp
        include/pcl/common/impl/eigen.hpp
        include/pcl/common/impl/intersections.hpp
        include/pcl/common/impl/copy_point.hpp
        include/pcl/common/impl/io.hpp
        include/pcl/common/impl/file_io.hpp
        include/pcl/common/impl/norms.hpp
        include/pcl/common/impl/piecewise_linear_function.hpp
        include/pcl/common/impl/polynomial_calculations.hpp
        include/pcl/common/impl/pca.hpp
        include/pcl/common/impl/transforms.hpp
        include/pcl/common/impl/transformation_from_correspondences.hpp
        include/pcl/common/impl/vector_average.hpp
        include/pcl/common/impl/gaussian.hpp
        include/pcl/common/impl/spring.hpp
        include/pcl/common/impl/intensity.hpp
        include/pcl/common/impl/random.hpp
        include/pcl/common/impl/generate.hpp
        include/pcl/common/impl/projection_matrix.hpp
        include/pcl/common/impl/accumulators.hpp
        )

    set(impl_incs 
        include/pcl/impl/pcl_base.hpp
        include/pcl/impl/instantiate.hpp
        include/pcl/impl/point_types.hpp
        include/pcl/impl/cloud_iterator.hpp
        )

    set(ros_incs 
        include/pcl/ros/conversions.h
        include/pcl/ros/register_point_struct.h
        )

    set(tools_incs 
        include/pcl/console/parse.h
        include/pcl/console/print.h
        include/pcl/console/time.h
        )
        
    set(kissfft_incs
        include/pcl/common/fft/_kiss_fft_guts.h
        include/pcl/common/fft/kiss_fft.h
        include/pcl/common/fft/kiss_fftr.h)
        
    set(kissfft_srcs
        src/fft/kiss_fft.c
        src/fft/kiss_fftr.c)

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${kissfft_srcs} ${incs} ${common_incs} ${impl_incs} ${ros_incs} ${tools_incs} ${kissfft_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})
    #PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${common_incs} ${impl_incs} ${ros_incs} ${tools_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "" ""
        "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common ${common_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/fft ${kissfft_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/impl ${common_incs_impl})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" impl ${impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" ros ${ros_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" console ${tools_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image ${range_image_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image/impl ${range_image_incs_impl})

endif(build)

=== doc/CMakeLists.txt ===
include(CMakeDependentOption)

cmake_dependent_option(WITH_TUTORIALS "Build tutorials (requires Sphinx)" FALSE "WITH_DOCS" FALSE)
if(WITH_TUTORIALS)
  find_package(Sphinx)
  if(SPHINX_FOUND)
    set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/_doctrees")
    set(SPHINX_HTML_FILE_SUFFIX "html" CACHE STRING "Suffix (extension) of the HTML files generated by Sphinx")
  endif(SPHINX_FOUND)
endif(WITH_TUTORIALS)

add_subdirectory(doxygen)
add_subdirectory(advanced)
add_subdirectory(tutorials)

=== features/CMakeLists.txt ===
set(SUBSYS_NAME features)
set(SUBSYS_DESC "Point cloud features library")
set(SUBSYS_DEPS common search kdtree octree filters 2d)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/eigen.h"
        "include/pcl/${SUBSYS_NAME}/board.h"
        "include/pcl/${SUBSYS_NAME}/brisk_2d.h"
        "include/pcl/${SUBSYS_NAME}/cppf.h"
        "include/pcl/${SUBSYS_NAME}/cvfh.h"
        "include/pcl/${SUBSYS_NAME}/our_cvfh.h"
        "include/pcl/${SUBSYS_NAME}/crh.h"
        "include/pcl/${SUBSYS_NAME}/don.h"
        "include/pcl/${SUBSYS_NAME}/feature.h"
        "include/pcl/${SUBSYS_NAME}/fpfh.h"
        "include/pcl/${SUBSYS_NAME}/fpfh_omp.h"
        "include/pcl/${SUBSYS_NAME}/from_meshes.h"
        "include/pcl/${SUBSYS_NAME}/gfpfh.h"
        "include/pcl/${SUBSYS_NAME}/integral_image2D.h"
        "include/pcl/${SUBSYS_NAME}/integral_image_normal.h"
        "include/pcl/${SUBSYS_NAME}/intensity_gradient.h"
        "include/pcl/${SUBSYS_NAME}/intensity_spin.h"
        "include/pcl/${SUBSYS_NAME}/linear_least_squares_normal.h"
        "include/pcl/${SUBSYS_NAME}/moment_invariants.h"
        "include/pcl/${SUBSYS_NAME}/moment_of_inertia_estimation.h"
        "include/pcl/${SUBSYS_NAME}/multiscale_feature_persistence.h"
        "include/pcl/${SUBSYS_NAME}/narf.h"
        "include/pcl/${SUBSYS_NAME}/narf_descriptor.h"
        "include/pcl/${SUBSYS_NAME}/normal_3d.h"
        "include/pcl/${SUBSYS_NAME}/normal_3d_omp.h"
        "include/pcl/${SUBSYS_NAME}/normal_based_signature.h"
        "include/pcl/${SUBSYS_NAME}/organized_edge_detection.h"
        "include/pcl/${SUBSYS_NAME}/pfh.h"
        "include/pcl/${SUBSYS_NAME}/pfh_tools.h"
        "include/pcl/${SUBSYS_NAME}/pfhrgb.h"
        "include/pcl/${SUBSYS_NAME}/ppf.h"
        "include/pcl/${SUBSYS_NAME}/ppfrgb.h"
        "include/pcl/${SUBSYS_NAME}/shot.h"
        "include/pcl/${SUBSYS_NAME}/shot_lrf.h"
        "include/pcl/${SUBSYS_NAME}/shot_lrf_omp.h"
        "include/pcl/${SUBSYS_NAME}/shot_omp.h"
        "include/pcl/${SUBSYS_NAME}/spin_image.h"
        "include/pcl/${SUBSYS_NAME}/principal_curvatures.h"
        "include/pcl/${SUBSYS_NAME}/rift.h"
        "include/pcl/${SUBSYS_NAME}/rops_estimation.h"
        "include/pcl/${SUBSYS_NAME}/rsd.h"
        "include/pcl/${SUBSYS_NAME}/grsd.h"
        "include/pcl/${SUBSYS_NAME}/statistical_multiscale_interest_region_extraction.h"
        "include/pcl/${SUBSYS_NAME}/vfh.h"
        "include/pcl/${SUBSYS_NAME}/esf.h"
        "include/pcl/${SUBSYS_NAME}/3dsc.h"
        "include/pcl/${SUBSYS_NAME}/usc.h"
        "include/pcl/${SUBSYS_NAME}/boundary.h"
        "include/pcl/${SUBSYS_NAME}/range_image_border_extractor.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/board.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/brisk_2d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cppf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cvfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/our_cvfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/crh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/don.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/feature.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fpfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fpfh_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/gfpfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/integral_image2D.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/integral_image_normal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/intensity_gradient.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/intensity_spin.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/linear_least_squares_normal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/moment_invariants.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/moment_of_inertia_estimation.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/multiscale_feature_persistence.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/narf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_3d_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_based_signature.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/organized_edge_detection.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/pfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/pfhrgb.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ppf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ppfrgb.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_lrf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_lrf_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/spin_image.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/principal_curvatures.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/rift.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/rops_estimation.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/rsd.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/grsd.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/statistical_multiscale_interest_region_extraction.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/vfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/esf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/3dsc.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/usc.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/boundary.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/range_image_border_extractor.hpp"
        )

    set(srcs
        src/board.cpp
        src/brisk_2d.cpp
        src/boundary.cpp
        src/cppf.cpp
        src/cvfh.cpp
        src/our_cvfh.cpp
        src/crh.cpp
        src/don.cpp
        src/fpfh.cpp
        src/gfpfh.cpp
        src/integral_image_normal.cpp
        src/intensity_gradient.cpp
        src/intensity_spin.cpp
        src/linear_least_squares_normal.cpp
        src/moment_invariants.cpp
        src/moment_of_inertia_estimation.cpp
        src/multiscale_feature_persistence.cpp
        src/narf.cpp
        src/normal_3d.cpp
        src/normal_based_signature.cpp
        src/organized_edge_detection.cpp
        src/pfh.cpp
        src/ppf.cpp
        src/shot.cpp
        src/shot_lrf.cpp
        src/spin_image.cpp
        src/principal_curvatures.cpp
        src/rift.cpp
        src/rops_estimation.cpp
        src/rsd.cpp
        src/grsd.cpp
        src/statistical_multiscale_interest_region_extraction.cpp
        src/vfh.cpp
        src/esf.cpp        
        src/3dsc.cpp
        src/usc.cpp
        src/range_image_border_extractor.cpp
       )
	
    if(MSVC)
      # Workaround to aviod hitting the MSVC 4GB linker memory limit when building pcl_features.
      # Disable whole program optimization (/GL) and link-time code generation (/LTCG).
      string(REPLACE "/GL" "" CMAKE_CXX_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
      string(REPLACE "/LTCG" "" CMAKE_SHARED_LINKER_FLAGS_RELEASE ${CMAKE_SHARED_LINKER_FLAGS_RELEASE}) 
    endif(MSVC)
	
    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_search pcl_kdtree pcl_octree pcl_filters)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install headers
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== gpu/CMakeLists.txt ===
set(SUBSYS_NAME gpu)
set(SUBSYS_DESC "Point cloud GPU libraries")
set(SUBSYS_DEPS )

OPTION(BUILD_GPU "Build the GPU-related subsystems" ${DEFAULT})

if(BUILD_GPU AND CUDA_FOUND)
    		
	if(CMAKE_COMPILER_IS_GNUCXX)
		string(REPLACE "-Wold-style-cast" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
		string(REPLACE "-Wno-invalid-offsetof" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-conversion -Wno-unused-parameter -Wno-unused-variable -Wno-unused-function")
    if (GCC_VERSION VERSION_GREATER 4.3)
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-but-set-variable")
    endif()
	endif()
	       
	collect_subproject_directory_names("${CMAKE_CURRENT_SOURCE_DIR}" "CMakeLists.txt" PCL_GPU_MODULES_NAMES PCL_GPU_MODULES_DIRS)
	set(PCL_GPU_MODULES_NAMES_UNSORTED ${PCL_GPU_MODULES_NAMES})
	topological_sort(PCL_GPU_MODULES_NAMES PCL_ _DEPENDS)
	sort_relative(PCL_GPU_MODULES_NAMES_UNSORTED PCL_GPU_MODULES_NAMES PCL_GPU_MODULES_DIRS)
	foreach(subdir ${PCL_GPU_MODULES_DIRS})
		add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/${subdir}")
	endforeach(subdir)    
endif()

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk rssdk pcap png vtk)
else(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk pcap png vtk libusb-1.0)
endif(WIN32)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    if(WITH_OPENNI2)
        set(IMAGE_INCLUDES
          include/pcl/io/image_metadata_wrapper.h
          include/pcl/io/image.h
          include/pcl/io/image_rgb24.h
          include/pcl/io/image_yuv422.h
          include/pcl/io/image_ir.h
          include/pcl/io/image_depth.h
        )

        set(IMAGE_SOURCES
          src/image_rgb24.cpp
          src/image_yuv422.cpp
          src/image_ir.cpp
          src/image_depth.cpp
        )

        set(OPENNI2_GRABBER_INCLUDES
            include/pcl/io/openni2_grabber.h
            )
        set(OPENNI2_INCLUDES
            include/pcl/io/openni2/openni.h
            include/pcl/io/openni2/openni2_metadata_wrapper.h
            include/pcl/io/openni2/openni2_frame_listener.h
            include/pcl/io/openni2/openni2_timer_filter.h
            include/pcl/io/openni2/openni2_video_mode.h
            include/pcl/io/openni2/openni2_convert.h
            include/pcl/io/openni2/openni2_device.h
            include/pcl/io/openni2/openni2_device_info.h
            include/pcl/io/openni2/openni2_device_manager.h
        )

        set(OPENNI2_GRABBER_SOURCES
            src/openni2_grabber.cpp
            src/openni2/openni2_timer_filter.cpp
            src/openni2/openni2_video_mode.cpp
            src/openni2/openni2_convert.cpp
            src/openni2/openni2_device.cpp
            src/openni2/openni2_device_info.cpp
            src/openni2/openni2_device_manager.cpp
        )

      source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
      source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

        # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
        if(MSVC)
            file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
        endif(MSVC)
    endif()

    if(WITH_OPENNI)
        set(OPENNI_GRABBER_INCLUDES
            include/pcl/io/openni_grabber.h
            include/pcl/io/oni_grabber.h
            )
        set(OPENNI_INCLUDES
            include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
            include/pcl/io/openni_camera/openni.h
            include/pcl/io/openni_camera/openni_depth_image.h
            include/pcl/io/openni_camera/openni_device.h
            include/pcl/io/openni_camera/openni_device_kinect.h
            include/pcl/io/openni_camera/openni_device_primesense.h
            include/pcl/io/openni_camera/openni_device_xtion.h
            include/pcl/io/openni_camera/openni_device_oni.h
            include/pcl/io/openni_camera/openni_driver.h
            include/pcl/io/openni_camera/openni_exception.h
            include/pcl/io/openni_camera/openni_image.h
            include/pcl/io/openni_camera/openni_image_bayer_grbg.h
            include/pcl/io/openni_camera/openni_image_yuv_422.h
            include/pcl/io/openni_camera/openni_image_rgb24.h
            include/pcl/io/openni_camera/openni_ir_image.h
           ${IMAGE_INCLUDES}
        )
        set(OPENNI_GRABBER_SOURCES
            src/openni_camera/openni_device.cpp
            src/openni_camera/openni_device_primesense.cpp
            src/openni_camera/openni_image_bayer_grbg.cpp
            src/openni_camera/openni_depth_image.cpp
            src/openni_camera/openni_ir_image.cpp
            src/openni_camera/openni_device_kinect.cpp
            src/openni_camera/openni_device_xtion.cpp
            src/openni_camera/openni_device_oni.cpp
            src/openni_camera/openni_driver.cpp
            src/openni_camera/openni_exception.cpp
            src/openni_camera/openni_image_yuv_422.cpp
            src/openni_camera/openni_image_rgb24.cpp
            src/openni_grabber.cpp
            src/oni_grabber.cpp
            ${IMAGE_SOURCES}
        )
    endif()

    source_group("Image Headers" FILES ${IMAGE_INCLUDES})
    source_group("Image Sources" FILES ${IMAGE_SOURCES})

    if(WITH_FZAPI)
        set(FZAPI_GRABBER_INCLUDES
            include/pcl/io/fotonic_grabber.h
            )
#        set(FZAPI_INCLUDES
#            include/pcl/io/openni_camera/openni.h
#            )
        set(FZAPI_GRABBER_SOURCES
            src/fotonic_grabber.cpp
            )
    endif()

    if(WITH_ENSENSO)
        set(ENSENSO_GRABBER_INCLUDES
            include/pcl/io/ensenso_grabber.h
            )
        set(ENSENSO_GRABBER_SOURCES
            src/ensenso_grabber.cpp
            )
    endif()

    if(WITH_DAVIDSDK AND VTK_FOUND) # VTK is mandatory for OBJ/PLY/STL input/output
        set(DAVIDSDK_GRABBER_INCLUDES
            include/pcl/io/davidsdk_grabber.h
            )
        set(DAVIDSDK_GRABBER_SOURCES
            src/davidsdk_grabber.cpp
            )
    endif()

    if(WITH_DSSDK)
        set(DSSDK_GRABBER_INCLUDES
            include/pcl/io/depth_sense_grabber.h
        )
        set(DSSDK_GRABBER_SOURCES
            src/depth_sense_grabber.cpp
            src/depth_sense/depth_sense_grabber_impl.cpp
            src/depth_sense/depth_sense_device_manager.cpp
        )
    endif()

    if(WITH_RSSDK)
        set(RSSDK_GRABBER_INCLUDES
            include/pcl/io/real_sense_grabber.h
        )
        set(RSSDK_GRABBER_SOURCES
            src/real_sense_grabber.cpp
            src/real_sense/real_sense_device_manager.cpp
        )
    endif()

    if(LIBUSB_1_FOUND)
        set(DINAST_GRABBER_INCLUDES
            include/pcl/io/dinast_grabber.h
           )
        set(DINAST_GRABBER_SOURCES
            src/dinast_grabber.cpp
           )
    endif(LIBUSB_1_FOUND)

    if (VTK_FOUND AND NOT ANDROID)
        set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
        include("${VTK_USE_FILE}")
        set(VTK_IO_INCLUDES
            "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
            "include/pcl/${SUBSYS_NAME}/png_io.h"
           )
        set(VTK_IO_INCLUDES_IMPL
            "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
           )
        set(VTK_IO_SOURCE
            src/vtk_lib_io.cpp
            src/png_io.cpp
           )
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging vtkHybrid vtkGraphics vtkRendering vtkFiltering vtkVolumeRendering)
        # Indicates that we can rely on VTK to be present
        set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
    endif ()

    set(PLY_SOURCES src/ply/ply_parser.cpp)
    set(PLY_INCLUDES
        "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
        "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
       )
    PCL_ADD_LIBRARY(pcl_io_ply "${SUBSYS_NAME}" ${PLY_SOURCES} ${PLY_INCLUDES})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})
    target_include_directories(pcl_io_ply PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")


    set(srcs
        src/debayer.cpp
        src/pcd_grabber.cpp
        src/pcd_io.cpp
        src/vtk_io.cpp
        src/ply_io.cpp
        src/ascii_io.cpp
        src/compression.cpp
        src/lzf.cpp
        src/lzf_image_io.cpp
        src/obj_io.cpp
        src/ifs_io.cpp
        src/image_grabber.cpp
        src/hdl_grabber.cpp
        src/vlp_grabber.cpp
        src/robot_eye_grabber.cpp
        src/file_io.cpp
        src/auto_io.cpp
        src/io_exception.cpp
        ${VTK_IO_SOURCE}
        ${OPENNI_GRABBER_SOURCES}
        ${OPENNI2_GRABBER_SOURCES}
        ${IMAGE_SOURCES}
        ${DINAST_GRABBER_SOURCES}
        ${FZAPI_GRABBER_SOURCES}
        ${ENSENSO_GRABBER_SOURCES}
        ${DAVIDSDK_GRABBER_SOURCES}
        ${DSSDK_GRABBER_SOURCES}
        ${RSSDK_GRABBER_SOURCES}
        )
    if(PNG_FOUND)
      list(APPEND srcs
          src/libpng_wrapper.cpp
          )
    endif(PNG_FOUND)

	if(PCAP_FOUND)
	  set(PCAP_DEFINES -DHAVE_PCAP)
          include_directories(${PCAP_INCLUDE_DIRS})
	  add_definitions(${PCAP_DEFINES})
	endif(PCAP_FOUND)

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/eigen.h"
        "include/pcl/${SUBSYS_NAME}/debayer.h"
        "include/pcl/${SUBSYS_NAME}/file_io.h"
        "include/pcl/${SUBSYS_NAME}/auto_io.h"
        "include/pcl/${SUBSYS_NAME}/lzf.h"
        "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
        "include/pcl/${SUBSYS_NAME}/io.h"
        "include/pcl/${SUBSYS_NAME}/grabber.h"
        "include/pcl/${SUBSYS_NAME}/file_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_io.h"
        "include/pcl/${SUBSYS_NAME}/vtk_io.h"
        "include/pcl/${SUBSYS_NAME}/ply_io.h"
        "include/pcl/${SUBSYS_NAME}/tar.h"
        "include/pcl/${SUBSYS_NAME}/obj_io.h"
        "include/pcl/${SUBSYS_NAME}/ascii_io.h"
        "include/pcl/${SUBSYS_NAME}/ifs_io.h"
        "include/pcl/${SUBSYS_NAME}/image_grabber.h"
        "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
        "include/pcl/${SUBSYS_NAME}/vlp_grabber.h"
        "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
        "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
        "include/pcl/${SUBSYS_NAME}/io_exception.h"
        ${VTK_IO_INCLUDES}
        ${OPENNI_GRABBER_INCLUDES}
        ${OPENNI2_GRABBER_INCLUDES}
        ${IMAGE_INCLUDES}
        ${DINAST_GRABBER_INCLUDES}
        ${FZAPI_GRABBER_INCLUDES}
        ${ENSENSO_GRABBER_INCLUDES}
        ${DAVIDSDK_GRABBER_INCLUDES}
        ${DSSDK_GRABBER_INCLUDES}
        ${RSSDK_GRABBER_INCLUDES}
        "include/pcl/${SUBSYS_NAME}/pxc_grabber.h"  # contains only depreciation note
        )

    set(compression_incs
        include/pcl/compression/octree_pointcloud_compression.h
        include/pcl/compression/color_coding.h
        include/pcl/compression/compression_profiles.h
        include/pcl/compression/entropy_range_coder.h
        include/pcl/compression/point_coding.h
       )
    if(PNG_FOUND)
      list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_conversion.h
          include/pcl/compression/libpng_wrapper.h
          )
      if(WITH_OPENNI OR WITH_OPENNI2)
        list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_compression.h
          )
      endif()
    endif(PNG_FOUND)

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/ascii_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/auto_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
        include/pcl/compression/impl/entropy_range_coder.hpp
        include/pcl/compression/impl/octree_pointcloud_compression.hpp
        ${VTK_IO_INCLUDES_IMPL}
       )
    if(PNG_FOUND AND (WITH_OPENNI OR WITH_OPENNI2))
     list(APPEND impl_incs
         include/pcl/compression/impl/organized_pointcloud_compression.hpp
        )
    endif()

    set(LIB_NAME "pcl_${SUBSYS_NAME}")

    add_definitions(${VTK_DEFINES})
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})
    target_include_directories(${LIB_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include" ${VTK_INCLUDE_DIRECTORIES})
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_io_ply ${VTK_LIBRARIES} )
    if(PNG_FOUND)

=== kdtree/CMakeLists.txt ===
set(SUBSYS_NAME kdtree)
set(SUBSYS_DESC "Point cloud kd-tree library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS flann)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs 
        src/kdtree_flann.cpp
        )

    set(incs 
        "include/pcl/${SUBSYS_NAME}/kdtree.h"
        "include/pcl/${SUBSYS_NAME}/io.h"
        "include/pcl/${SUBSYS_NAME}/flann.h"
        "include/pcl/${SUBSYS_NAME}/kdtree_flann.h"
        )

    set(impl_incs 
        "include/pcl/${SUBSYS_NAME}/impl/io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/kdtree_flann.hpp"
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_common ${FLANN_LIBRARIES})
    set(EXT_DEPS flann)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}"
                       "${SUBSYS_DEPS}" "${EXT_DEPS}" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== keypoints/CMakeLists.txt ===
set(SUBSYS_NAME keypoints)
set(SUBSYS_DESC "Point cloud keypoints library")
set(SUBSYS_DEPS common search kdtree octree features filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs
        src/narf_keypoint.cpp
        src/sift_keypoint.cpp
        src/smoothed_surfaces_keypoint.cpp
        src/harris_3d.cpp
        src/harris_6d.cpp
        src/agast_2d.cpp
        src/susan.cpp
        src/iss_3d.cpp
        src/brisk_2d.cpp
        )
    set(incs
        "include/pcl/${SUBSYS_NAME}/keypoint.h"
        "include/pcl/${SUBSYS_NAME}/narf_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/sift_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/uniform_sampling.h"
        "include/pcl/${SUBSYS_NAME}/smoothed_surfaces_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/agast_2d.h"
        "include/pcl/${SUBSYS_NAME}/harris_2d.h"
        "include/pcl/${SUBSYS_NAME}/harris_3d.h"
        "include/pcl/${SUBSYS_NAME}/harris_6d.h"
        "include/pcl/${SUBSYS_NAME}/susan.h"
        "include/pcl/${SUBSYS_NAME}/iss_3d.h"
        "include/pcl/${SUBSYS_NAME}/brisk_2d.h"
        )
    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/sift_keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/smoothed_surfaces_keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/agast_2d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/harris_2d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/harris_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/harris_6d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/susan.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/iss_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/brisk_2d.hpp"
        )
    
    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_features pcl_filters)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== ml/CMakeLists.txt ===
set(SUBSYS_NAME ml)
set(SUBSYS_DESC "Point cloud machine learning library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(incs 
        "include/pcl/${SUBSYS_NAME}/dt/decision_forest.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_forest_evaluator.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_forest_trainer.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_tree.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_tree_evaluator.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_tree_trainer.h"
        "include/pcl/${SUBSYS_NAME}/dt/decision_tree_data_provider.h"
        "include/pcl/${SUBSYS_NAME}/ferns/fern.h"
        "include/pcl/${SUBSYS_NAME}/ferns/fern_evaluator.h"
        "include/pcl/${SUBSYS_NAME}/ferns/fern_trainer.h"
        "include/pcl/${SUBSYS_NAME}/branch_estimator.h"
        "include/pcl/${SUBSYS_NAME}/feature_handler.h"
        "include/pcl/${SUBSYS_NAME}/multi_channel_2d_comparison_feature.h"
        "include/pcl/${SUBSYS_NAME}/multi_channel_2d_comparison_feature_handler.h"
        "include/pcl/${SUBSYS_NAME}/multi_channel_2d_data_set.h"
        "include/pcl/${SUBSYS_NAME}/multiple_data_2d_example_index.h"
        "include/pcl/${SUBSYS_NAME}/point_xy_32i.h"
        "include/pcl/${SUBSYS_NAME}/point_xy_32f.h"
        "include/pcl/${SUBSYS_NAME}/regression_variance_stats_estimator.h"
        "include/pcl/${SUBSYS_NAME}/stats_estimator.h"
	"include/pcl/${SUBSYS_NAME}/densecrf.h"
	"include/pcl/${SUBSYS_NAME}/pairwise_potential.h"
	"include/pcl/${SUBSYS_NAME}/permutohedral.h"
	#"include/pcl/${SUBSYS_NAME}/util.h"
	#"include/pcl/${SUBSYS_NAME}/permutohedralORI.h"
	#"include/pcl/${SUBSYS_NAME}/fastmath.h"
	#"include/pcl/${SUBSYS_NAME}/densecrfORI.h"
        "include/pcl/${SUBSYS_NAME}/svm_wrapper.h"
        "include/pcl/${SUBSYS_NAME}/svm.h"
	"include/pcl/${SUBSYS_NAME}/kmeans.h"
        )

    set(impl_incs 
        "include/pcl/${SUBSYS_NAME}/impl/dt/decision_forest_evaluator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/dt/decision_forest_trainer.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/dt/decision_tree_evaluator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/dt/decision_tree_trainer.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ferns/fern_evaluator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ferns/fern_trainer.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/svm/svm_wrapper.hpp"
	#"include/pcl/${SUBSYS_NAME}/impl/kmeans.hpp"
        )

    set(srcs
		src/point_xy_32i.cpp
		src/point_xy_32f.cpp
		src/densecrf.cpp
		src/pairwise_potential.cpp
		src/permutohedral.cpp
		#src/permutohedralORI.cpp
		#src/filter.cpp
		#src/util.cpp
		#src/densecrfORI.cpp		
		src/svm_wrapper.cpp
		src/svm.cpp
		src/kmeans.cpp
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
	SET_TARGET_PROPERTIES("${LIB_NAME}" PROPERTIES LINKER_LANGUAGE CXX)
    target_link_libraries("${LIB_NAME}" pcl_common)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})

endif(build)

=== octree/CMakeLists.txt ===
set(SUBSYS_NAME octree)
set(SUBSYS_DESC "Point cloud octree library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs src/octree_inst.cpp
    )

    set(incs 
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/octree_base.h"
        "include/pcl/${SUBSYS_NAME}/octree_container.h"
        "include/pcl/${SUBSYS_NAME}/octree_impl.h"
        "include/pcl/${SUBSYS_NAME}/octree_nodes.h"
        "include/pcl/${SUBSYS_NAME}/octree_key.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_density.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_occupancy.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_singlepoint.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_pointvector.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_changedetector.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_voxelcentroid.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud.h"
        "include/pcl/${SUBSYS_NAME}/octree_iterator.h"
        "include/pcl/${SUBSYS_NAME}/octree_search.h"
        "include/pcl/${SUBSYS_NAME}/octree.h"
        "include/pcl/${SUBSYS_NAME}/octree2buf_base.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_adjacency.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_adjacency_container.h"
        )

    set(impl_incs    
        "include/pcl/${SUBSYS_NAME}/impl/octree_base.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree2buf_base.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_iterator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_search.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud_voxelcentroid.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud_adjacency.hpp"
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}")
    target_include_directories(${LIB_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}"
      "${SUBSYS_DEPS}" "" "" "" "")
 
    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== debian/changelog ===
pcl (1.8.1+dfsg1-7) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * simplify rules

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 15 Sep 2018 13:21:39 +0200

pcl (1.8.1+dfsg1-6) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * use --max-parallel=2 for Ubuntu
  * Add patch for pcl_2d-1.8.pc

  [ Adrian Bunk ]
  * Reduce the amount of debug information when building for 32bit architectures
    (Closes: #908820)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 14 Sep 2018 21:27:30 +0200

pcl (1.8.1+dfsg1-5) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Limit parallel builds on Ubuntu

  [ Jochen Sprickerhof ]
  * Add patches for Boost 1.67
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 11 Sep 2018 21:56:53 +0200

pcl (1.8.1+dfsg1-4) unstable; urgency=medium

  * Disable automatic SSE detection (LP: #1771124)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 23 Jun 2018 18:59:00 +0200

pcl (1.8.1+dfsg1-3) unstable; urgency=medium

  * remove list-missing (now done by dh_missing)
  * Fix priority
  * Update Vcs URLs to salsa.d.o
  * Add R³
  * http -> https
  * Add patch for GCC8 (Closes: #897833)
  * Bump policy and debhelper versions
  * Fix documentation location

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 06 May 2018 12:15:00 +0200

=== debian/control ===
Source: pcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
	   Jochen Sprickerhof <jspricke@debian.org>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11), dh-exec,
               cmake,
	       python3-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev, 
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk6-dev,
	       libqhull-dev,
	       libopenni-dev [!s390x !alpha !hppa !hurd-i386 !kfreebsd-any !m68k !sh4 !sparc64],
	       libopenni2-dev [!armel !hppa !hurd-i386 !kfreebsd-any !m68k !powerpcspe],
	       libqt5opengl5-dev [!armel !armhf],
	       libusb-1.0-0-dev,
	       freeglut3-dev, 
	       libxmu-dev,
	       libxi-dev,
	       libvtk6-qt-dev [!armel !armhf]
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/pcl
Vcs-Git: https://salsa.debian.org/science-team/pcl.git
Rules-Requires-Root: no
Homepage: http://www.pointclouds.org/

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk6-dev,
	 libqhull-dev,
	 libvtk6-qt-dev [!armel !armhf],
	 libopenni-dev [!s390x !alpha !hppa !hurd-i386 !kfreebsd-any !m68k !sh4 !sparc64],
	 libopenni2-dev [!armel !hppa !hurd-i386 !kfreebsd-any !m68k !powerpcspe],
	 libpcl-apps1.8 (= ${binary:Version}),
	 libpcl-common1.8 (= ${binary:Version}),
	 libpcl-features1.8 (= ${binary:Version}),
	 libpcl-filters1.8 (= ${binary:Version}),
	 libpcl-io1.8 (= ${binary:Version}),
	 libpcl-kdtree1.8 (= ${binary:Version}),
	 libpcl-keypoints1.8 (= ${binary:Version}),
	 libpcl-ml1.8 (= ${binary:Version}),
	 libpcl-octree1.8 (= ${binary:Version}),
	 libpcl-outofcore1.8 (= ${binary:Version}),
	 libpcl-people1.8 (= ${binary:Version}),
	 libpcl-recognition1.8 (= ${binary:Version}),
	 libpcl-registration1.8 (= ${binary:Version}),
	 libpcl-sample-consensus1.8 (= ${binary:Version}),
	 libpcl-search1.8 (= ${binary:Version}),
	 libpcl-segmentation1.8 (= ${binary:Version}),
	 libpcl-stereo1.8 (= ${binary:Version}),
	 libpcl-surface1.8 (= ${binary:Version}),
	 libpcl-tracking1.8 (= ${binary:Version}),
	 libpcl-visualization1.8 (= ${binary:Version}),
	 ${misc:Depends}
Suggests: libpcl-doc
Description: Point Cloud Library - development files
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl-apps1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - apps library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending 
 on PCL apps.

Package: libpcl-common1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - common library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL common library.

Package: libpcl-features1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - features library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL features library.

Package: libpcl-filters1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - filters library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL filters library.

Package: libpcl-io1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - I/O library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL io.

Package: libpcl-kdtree1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - kdtree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - keypoints library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL keypoints library.

Package: libpcl-ml1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - ml library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL ml library.

Package: libpcl-octree1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - octree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL octree library.

Package: libpcl-outofcore1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - outofcore library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL outofcore.

Package: libpcl-people1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - people library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL people.

Package: libpcl-recognition1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
    	 ${misc:Depends}
Description: Point Cloud Library - recognition library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL recognition.

Package: libpcl-registration1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - registration library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - sample consensus library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - search library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - segmentation library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL segmentation library.

Package: libpcl-stereo1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - stereo library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) -g1
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)

# Multiarch.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

.PHONY: override_dh_auto_configure \
	override_dh_install \
	override_dh_installchangelogs

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON -DPCL_ENABLE_SSE=OFF			\
	-DBUILD_TESTS=OFF -DBUILD_apps=ON -DBUILD_common=ON		\
	-DBUILD_examples=ON -DBUILD_features=ON -DBUILD_filters=ON	\
	-DBUILD_geometry=ON -DBUILD_global_tests=OFF -DBUILD_io=ON	\
	-DBUILD_kdtree=ON -DBUILD_keypoints=ON -DBUILD_octree=ON	\
	-DBUILD_registration=ON -DBUILD_sample_consensus=ON		\
	-DBUILD_search=ON -DBUILD_segmentation=ON -DBUILD_surface=ON	\
	-DBUILD_tools=ON -DBUILD_tracking=ON -DBUILD_visualization=ON   \
	-DBUILD_apps_cloud_composer=OFF -DBUILD_apps_modeler=ON            \
	-DBUILD_apps_point_cloud_editor=ON -DBUILD_apps_in_hand_scanner=ON \
	$(BUILD_DOC)

override_dh_install:
	@for i in pcl_concatenate_points_pcd pcl_grabcut_2d \
		pcl_elch pcl_dinast_grabber pcl_hdl_grabber \
		pcl_icp pcl_icp2d pcl_lum pcl_manual_registration pcl_match_linemod_template \
		pcl_multiscale_feature_persistence_example pcl_ndt2d pcl_ndt3d pcl_ni_agast \
		pcl_ni_linemod pcl_ni_susan pcl_nn_classification_example \
		pcl_obj_rec_ransac_hash_table pcl_openni_grabber_depth_example \
		pcl_openni_grabber_example pcl_openni_mobile_server \
		pcl_openni_organized_multi_plane_segmentation \
		pcl_openni_passthrough pcl_openni_shift_to_depth_conversion \
		pcl_openni_voxel_grid pcl_organized_segmentation_demo pcl_outofcore_print \
		pcl_outofcore_process pcl_pcd_image_viewer \
		pcl_pcd_organized_multi_plane_segmentation pcl_pcd_video_player \
		pcl_point_cloud_editor pcl_pyramid_surface_matching pcl_radius_filter \
		pcl_statistical_multiscale_interest_region_extraction_example \
		pcl_registration_visualizer pcl_surfel_smoothing_test \
		pcl_timed_trigger_test pcl_viewer pcl_virtual_scanner \
		pcl_voxel_grid_occlusion_estimation pcl_compute_hausdorff \
		pcl_generate pcl_grid_min pcl_in_hand_scanner pcl_local_max \
		pcl_morph pcl_ni_trajkovic pcl_obj2pcd pcl_offline_integration 	\
		pcl_openni_klt pcl_progressive_morphological_filter \
		pcl_converter pcl_crf_segmentation pcl_face_trainer pcl_fs_face_detector \
		pcl_ni_brisk pcl_obj2ply pcl_openni_face_detector \
		pcl_openni_organized_edge_detection pcl_outofcore_viewer \
		pcl_pcd_introduce_nan pcl_pcd_organized_edge_detection \
		pcl_stereo_ground_segmentation pcl_train_unary_classifier \
		pcl_unary_classifier_segment pcl_vlp_viewer pcl_openni2_viewer \
		pcl_openni_organized_multi_plane_segmentation; do \
	cmd="dh_link -p pcl-tools usr/share/man/man1/pcl_pointclouds.1 usr/share/man/man1/$$i.1"; \
	echo $$cmd; $$cmd; \
	done
		
	dh_install

#override_dh_shlibdeps:
#	dh_shlibdeps -v -Xusr/bin/pcl_* -Lpcl-tools -l:$(CURDIR)/debian/usr/lib/${DEB_HOST_MULTIARCH}/cloud_composer_plugins: -ppcl --- -xpcl-tools -v

override_dh_installchangelogs:
	dh_installchangelogs -plibpcl-common1.8 CHANGES.md
	# Creating dh_links to share the same file
	@for i in libpcl-dev libpcl1.8 libpcl-apps1.8 \
		libpcl-features1.8 libpcl-filters1.8 libpcl-io1.8 libpcl-kdtree1.8 \
		libpcl-keypoints1.8 libpcl-octree1.8 libpcl-outofcore1.8 libpcl-people1.8 \
		libpcl-recognition1.8 libpcl-registration1.8 libpcl-sample-consensus1.8 \
		libpcl-search1.8 libpcl-segmentation1.8 libpcl-stereo1.8 \
		libpcl-surface1.8 libpcl-tracking1.8 libpcl-visualization1.8 \
		pcl-tools libpcl-doc; do \
	cmd="dh_link -p$$i usr/share/doc/libpcl-common1.8/changelog.gz usr/share/doc/$$i/changelog.gz"; \
	echo $$cmd; $$cmd; \
	done
	dh_installchangelogs


%:
	dh  $@ --builddirectory=build
